#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>
#include <math.h>
bool pause = true;
float angle = 0;
// draw a square, centered at the origin, with sides of length s.
void drawSquare(float s)
{
	float tr = s/2;
	glBegin( GL_LINE_STRIP );
	    glVertex3f( tr, tr, 0.0 );
		glVertex3f( tr,-tr, 0.0 );
		glVertex3f( -tr, -tr, 0.0);
		glVertex3f( -tr,tr, 0.0 );
		glVertex3f( tr,tr, 0.0 );
    glEnd();
}

void DrawWorld()
{

	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

    // clear the color buffer
	glClearColor(.5,.5,.5,1);
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	  // scale the world down by a factor of 10
	glScalef(0.1, 0.1, 0.1);

	  // draw lines marking the origin
	glColor3f(1,0.5,0.5);      // change current colour to be reddish
	glBegin(GL_LINE_STRIP);
	glVertex3f(0,1,0);
	glVertex3f(0,0,0);
	glVertex3f(1,0,0);
	glEnd();
	glColor3f(1,1,1);          // change current colour to white

	glRotatef(30,0,0,1);       // rotate 30 degrees about z
	drawSquare(1);
    // draw the buffer to the screen
    glutSwapBuffers();
}

void Idle()
{
	if (!pause)
		angle += 0.50;
    glutPostRedisplay();
}

void keyhit(unsigned char key, int x, int y)
{
	switch(key) {
	case 'a':
		printf("you hit the 'a' key\n");
		break;

	case ' ':
		pause = !pause;
		break;

	case 'q':
		exit(0);
		break;
	}
}

int main(int argc, char **argv)
{
    // create window and rendering context
    glutInit( &argc, argv );
	glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );
	glutInitWindowSize( 800,800 );
	glutCreateWindow( "Robot Arm" );
	glutDisplayFunc( DrawWorld );
	glutIdleFunc(Idle);
	glutKeyboardFunc(keyhit);
	glEnable(GL_DEPTH_TEST);
    // pass control over to GLUT
	glutMainLoop();

	return 0;       // never reached
}

